# coding: utf-8

"""
    Model Catalog

    This is the API of the Software Description Ontology at [https://w3id.org/okn/o/sdm](https://w3id.org/okn/o/sdm)  # noqa: E501

    The version of the OpenAPI document: v1.7.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class SoftwareImage(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'has_download_instructions': 'list[str]',
        'keywords': 'list[str]',
        'has_documentation': 'list[str]',
        'software_requirements': 'list[str]',
        'has_download_url': 'list[str]',
        'type': 'list[str]',
        'has_installation_instructions': 'list[str]',
        'compatible_visualization_software': 'list[Software]',
        'copyright_holder': 'list[object]',
        'has_faq': 'list[str]',
        'logo': 'list[Image]',
        'has_contact_person': 'list[object]',
        'id': 'str',
        'identifier': 'list[str]',
        'author': 'list[object]',
        'has_build_file': 'list[str]',
        'short_description': 'list[str]',
        'has_execution_command': 'list[str]',
        'date_published': 'list[str]',
        'license': 'list[str]',
        'has_source_code': 'list[SourceCode]',
        'has_example': 'list[str]',
        'publisher': 'list[object]',
        'doi': 'list[str]',
        'has_funding': 'list[FundingInformation]',
        'support_details': 'list[str]',
        'has_version': 'list[SoftwareVersion]',
        'has_typical_data_source': 'list[str]',
        'description': 'list[str]',
        'reference_publication': 'list[str]',
        'screenshot': 'list[Image]',
        'had_primary_source': 'list[object]',
        'issue_tracker': 'list[str]',
        'date_created': 'list[str]',
        'contributor': 'list[Person]',
        'available_in_registry': 'list[str]',
        'has_purpose': 'list[str]',
        'has_executable_instructions': 'list[str]',
        'has_sample_visualization': 'list[Visualization]',
        'memory_requirements': 'list[str]',
        'website': 'list[str]',
        'citation': 'list[str]',
        'processor_requirements': 'list[str]',
        'has_usage_notes': 'list[str]',
        'readme': 'list[str]',
        'label': 'list[str]',
        'has_assumption': 'list[str]',
        'operating_systems': 'list[str]',
        'has_executable_notebook': 'list[str]',
        'useful_for_calculating_index': 'list[NumericalIndex]'
    }

    attribute_map = {
        'has_download_instructions': 'hasDownloadInstructions',
        'keywords': 'keywords',
        'has_documentation': 'hasDocumentation',
        'software_requirements': 'softwareRequirements',
        'has_download_url': 'hasDownloadURL',
        'type': 'type',
        'has_installation_instructions': 'hasInstallationInstructions',
        'compatible_visualization_software': 'compatibleVisualizationSoftware',
        'copyright_holder': 'copyrightHolder',
        'has_faq': 'hasFAQ',
        'logo': 'logo',
        'has_contact_person': 'hasContactPerson',
        'id': 'id',
        'identifier': 'identifier',
        'author': 'author',
        'has_build_file': 'hasBuildFile',
        'short_description': 'shortDescription',
        'has_execution_command': 'hasExecutionCommand',
        'date_published': 'datePublished',
        'license': 'license',
        'has_source_code': 'hasSourceCode',
        'has_example': 'hasExample',
        'publisher': 'publisher',
        'doi': 'doi',
        'has_funding': 'hasFunding',
        'support_details': 'supportDetails',
        'has_version': 'hasVersion',
        'has_typical_data_source': 'hasTypicalDataSource',
        'description': 'description',
        'reference_publication': 'referencePublication',
        'screenshot': 'screenshot',
        'had_primary_source': 'hadPrimarySource',
        'issue_tracker': 'issueTracker',
        'date_created': 'dateCreated',
        'contributor': 'contributor',
        'available_in_registry': 'availableInRegistry',
        'has_purpose': 'hasPurpose',
        'has_executable_instructions': 'hasExecutableInstructions',
        'has_sample_visualization': 'hasSampleVisualization',
        'memory_requirements': 'memoryRequirements',
        'website': 'website',
        'citation': 'citation',
        'processor_requirements': 'processorRequirements',
        'has_usage_notes': 'hasUsageNotes',
        'readme': 'readme',
        'label': 'label',
        'has_assumption': 'hasAssumption',
        'operating_systems': 'operatingSystems',
        'has_executable_notebook': 'hasExecutableNotebook',
        'useful_for_calculating_index': 'usefulForCalculatingIndex'
    }

    def __init__(self, has_download_instructions=None, keywords=None, has_documentation=None, software_requirements=None, has_download_url=None, type=None, has_installation_instructions=None, compatible_visualization_software=None, copyright_holder=None, has_faq=None, logo=None, has_contact_person=None, id=None, identifier=None, author=None, has_build_file=None, short_description=None, has_execution_command=None, date_published=None, license=None, has_source_code=None, has_example=None, publisher=None, doi=None, has_funding=None, support_details=None, has_version=None, has_typical_data_source=None, description=None, reference_publication=None, screenshot=None, had_primary_source=None, issue_tracker=None, date_created=None, contributor=None, available_in_registry=None, has_purpose=None, has_executable_instructions=None, has_sample_visualization=None, memory_requirements=None, website=None, citation=None, processor_requirements=None, has_usage_notes=None, readme=None, label=None, has_assumption=None, operating_systems=None, has_executable_notebook=None, useful_for_calculating_index=None):  # noqa: E501
        """SoftwareImage - a model defined in OpenAPI"""  # noqa: E501

        self._has_download_instructions = None
        self._keywords = None
        self._has_documentation = None
        self._software_requirements = None
        self._has_download_url = None
        self._type = None
        self._has_installation_instructions = None
        self._compatible_visualization_software = None
        self._copyright_holder = None
        self._has_faq = None
        self._logo = None
        self._has_contact_person = None
        self._id = None
        self._identifier = None
        self._author = None
        self._has_build_file = None
        self._short_description = None
        self._has_execution_command = None
        self._date_published = None
        self._license = None
        self._has_source_code = None
        self._has_example = None
        self._publisher = None
        self._doi = None
        self._has_funding = None
        self._support_details = None
        self._has_version = None
        self._has_typical_data_source = None
        self._description = None
        self._reference_publication = None
        self._screenshot = None
        self._had_primary_source = None
        self._issue_tracker = None
        self._date_created = None
        self._contributor = None
        self._available_in_registry = None
        self._has_purpose = None
        self._has_executable_instructions = None
        self._has_sample_visualization = None
        self._memory_requirements = None
        self._website = None
        self._citation = None
        self._processor_requirements = None
        self._has_usage_notes = None
        self._readme = None
        self._label = None
        self._has_assumption = None
        self._operating_systems = None
        self._has_executable_notebook = None
        self._useful_for_calculating_index = None
        self.discriminator = None

        self.has_download_instructions = has_download_instructions
        self.keywords = keywords
        self.has_documentation = has_documentation
        self.software_requirements = software_requirements
        self.has_download_url = has_download_url
        self.type = type
        self.has_installation_instructions = has_installation_instructions
        self.compatible_visualization_software = compatible_visualization_software
        self.copyright_holder = copyright_holder
        self.has_faq = has_faq
        self.logo = logo
        self.has_contact_person = has_contact_person
        if id is not None:
            self.id = id
        self.identifier = identifier
        self.author = author
        self.has_build_file = has_build_file
        self.short_description = short_description
        self.has_execution_command = has_execution_command
        self.date_published = date_published
        self.license = license
        self.has_source_code = has_source_code
        self.has_example = has_example
        self.publisher = publisher
        self.doi = doi
        self.has_funding = has_funding
        self.support_details = support_details
        self.has_version = has_version
        self.has_typical_data_source = has_typical_data_source
        self.description = description
        self.reference_publication = reference_publication
        self.screenshot = screenshot
        self.had_primary_source = had_primary_source
        self.issue_tracker = issue_tracker
        self.date_created = date_created
        self.contributor = contributor
        self.available_in_registry = available_in_registry
        self.has_purpose = has_purpose
        self.has_executable_instructions = has_executable_instructions
        self.has_sample_visualization = has_sample_visualization
        self.memory_requirements = memory_requirements
        self.website = website
        self.citation = citation
        self.processor_requirements = processor_requirements
        self.has_usage_notes = has_usage_notes
        self.readme = readme
        self.label = label
        self.has_assumption = has_assumption
        self.operating_systems = operating_systems
        self.has_executable_notebook = has_executable_notebook
        self.useful_for_calculating_index = useful_for_calculating_index

    @property
    def has_download_instructions(self):
        """Gets the has_download_instructions of this SoftwareImage.  # noqa: E501

        Instructions needed to download a software component. The difference with `hasDownloadURL` is that this property captures the human readable instructions required to download software. For example, sometimes an authentication is needed, users need to fill in a form, etc.  # noqa: E501

        :return: The has_download_instructions of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._has_download_instructions

    @has_download_instructions.setter
    def has_download_instructions(self, has_download_instructions):
        """Sets the has_download_instructions of this SoftwareImage.

        Instructions needed to download a software component. The difference with `hasDownloadURL` is that this property captures the human readable instructions required to download software. For example, sometimes an authentication is needed, users need to fill in a form, etc.  # noqa: E501

        :param has_download_instructions: The has_download_instructions of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._has_download_instructions = has_download_instructions

    @property
    def keywords(self):
        """Gets the keywords of this SoftwareImage.  # noqa: E501

        Keywords associated with a software component  # noqa: E501

        :return: The keywords of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._keywords

    @keywords.setter
    def keywords(self, keywords):
        """Sets the keywords of this SoftwareImage.

        Keywords associated with a software component  # noqa: E501

        :param keywords: The keywords of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._keywords = keywords

    @property
    def has_documentation(self):
        """Gets the has_documentation of this SoftwareImage.  # noqa: E501

        Pointer to the documentation of the model  # noqa: E501

        :return: The has_documentation of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._has_documentation

    @has_documentation.setter
    def has_documentation(self, has_documentation):
        """Sets the has_documentation of this SoftwareImage.

        Pointer to the documentation of the model  # noqa: E501

        :param has_documentation: The has_documentation of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._has_documentation = has_documentation

    @property
    def software_requirements(self):
        """Gets the software_requirements of this SoftwareImage.  # noqa: E501

        Software requirements needed to install a software component  # noqa: E501

        :return: The software_requirements of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._software_requirements

    @software_requirements.setter
    def software_requirements(self, software_requirements):
        """Sets the software_requirements of this SoftwareImage.

        Software requirements needed to install a software component  # noqa: E501

        :param software_requirements: The software_requirements of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._software_requirements = software_requirements

    @property
    def has_download_url(self):
        """Gets the has_download_url of this SoftwareImage.  # noqa: E501

        Download URL where to obtain the source/executable of the software  # noqa: E501

        :return: The has_download_url of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._has_download_url

    @has_download_url.setter
    def has_download_url(self, has_download_url):
        """Sets the has_download_url of this SoftwareImage.

        Download URL where to obtain the source/executable of the software  # noqa: E501

        :param has_download_url: The has_download_url of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._has_download_url = has_download_url

    @property
    def type(self):
        """Gets the type of this SoftwareImage.  # noqa: E501

        type of the resource  # noqa: E501

        :return: The type of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this SoftwareImage.

        type of the resource  # noqa: E501

        :param type: The type of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._type = type

    @property
    def has_installation_instructions(self):
        """Gets the has_installation_instructions of this SoftwareImage.  # noqa: E501

        Instructions required to install this particular piece of software. Installation instructions usually are available in a human-readable manner.  # noqa: E501

        :return: The has_installation_instructions of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._has_installation_instructions

    @has_installation_instructions.setter
    def has_installation_instructions(self, has_installation_instructions):
        """Sets the has_installation_instructions of this SoftwareImage.

        Instructions required to install this particular piece of software. Installation instructions usually are available in a human-readable manner.  # noqa: E501

        :param has_installation_instructions: The has_installation_instructions of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._has_installation_instructions = has_installation_instructions

    @property
    def compatible_visualization_software(self):
        """Gets the compatible_visualization_software of this SoftwareImage.  # noqa: E501

        Property that links a software component to other useful software that canbe used to visualize its outputs  # noqa: E501

        :return: The compatible_visualization_software of this SoftwareImage.  # noqa: E501
        :rtype: list[Software]
        """
        return self._compatible_visualization_software

    @compatible_visualization_software.setter
    def compatible_visualization_software(self, compatible_visualization_software):
        """Sets the compatible_visualization_software of this SoftwareImage.

        Property that links a software component to other useful software that canbe used to visualize its outputs  # noqa: E501

        :param compatible_visualization_software: The compatible_visualization_software of this SoftwareImage.  # noqa: E501
        :type: list[Software]
        """

        self._compatible_visualization_software = compatible_visualization_software

    @property
    def copyright_holder(self):
        """Gets the copyright_holder of this SoftwareImage.  # noqa: E501

        Copyright holder for a software component  # noqa: E501

        :return: The copyright_holder of this SoftwareImage.  # noqa: E501
        :rtype: list[object]
        """
        return self._copyright_holder

    @copyright_holder.setter
    def copyright_holder(self, copyright_holder):
        """Sets the copyright_holder of this SoftwareImage.

        Copyright holder for a software component  # noqa: E501

        :param copyright_holder: The copyright_holder of this SoftwareImage.  # noqa: E501
        :type: list[object]
        """

        self._copyright_holder = copyright_holder

    @property
    def has_faq(self):
        """Gets the has_faq of this SoftwareImage.  # noqa: E501

        Frequently asked questions about a software  # noqa: E501

        :return: The has_faq of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._has_faq

    @has_faq.setter
    def has_faq(self, has_faq):
        """Sets the has_faq of this SoftwareImage.

        Frequently asked questions about a software  # noqa: E501

        :param has_faq: The has_faq of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._has_faq = has_faq

    @property
    def logo(self):
        """Gets the logo of this SoftwareImage.  # noqa: E501

        Property that links to the image used as logo for a software component  # noqa: E501

        :return: The logo of this SoftwareImage.  # noqa: E501
        :rtype: list[Image]
        """
        return self._logo

    @logo.setter
    def logo(self, logo):
        """Sets the logo of this SoftwareImage.

        Property that links to the image used as logo for a software component  # noqa: E501

        :param logo: The logo of this SoftwareImage.  # noqa: E501
        :type: list[Image]
        """

        self._logo = logo

    @property
    def has_contact_person(self):
        """Gets the has_contact_person of this SoftwareImage.  # noqa: E501

        Contact person responsible for a software component  # noqa: E501

        :return: The has_contact_person of this SoftwareImage.  # noqa: E501
        :rtype: list[object]
        """
        return self._has_contact_person

    @has_contact_person.setter
    def has_contact_person(self, has_contact_person):
        """Sets the has_contact_person of this SoftwareImage.

        Contact person responsible for a software component  # noqa: E501

        :param has_contact_person: The has_contact_person of this SoftwareImage.  # noqa: E501
        :type: list[object]
        """

        self._has_contact_person = has_contact_person

    @property
    def id(self):
        """Gets the id of this SoftwareImage.  # noqa: E501

        identifier  # noqa: E501

        :return: The id of this SoftwareImage.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this SoftwareImage.

        identifier  # noqa: E501

        :param id: The id of this SoftwareImage.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def identifier(self):
        """Gets the identifier of this SoftwareImage.  # noqa: E501

        Identifier of the resource being described  # noqa: E501

        :return: The identifier of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._identifier

    @identifier.setter
    def identifier(self, identifier):
        """Sets the identifier of this SoftwareImage.

        Identifier of the resource being described  # noqa: E501

        :param identifier: The identifier of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._identifier = identifier

    @property
    def author(self):
        """Gets the author of this SoftwareImage.  # noqa: E501

        The creator of a software component  # noqa: E501

        :return: The author of this SoftwareImage.  # noqa: E501
        :rtype: list[object]
        """
        return self._author

    @author.setter
    def author(self, author):
        """Sets the author of this SoftwareImage.

        The creator of a software component  # noqa: E501

        :param author: The author of this SoftwareImage.  # noqa: E501
        :type: list[object]
        """

        self._author = author

    @property
    def has_build_file(self):
        """Gets the has_build_file of this SoftwareImage.  # noqa: E501

        A file (e.g., Dockerfile) with executable instructions indicating how a Software Image or a Software component is built  # noqa: E501

        :return: The has_build_file of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._has_build_file

    @has_build_file.setter
    def has_build_file(self, has_build_file):
        """Sets the has_build_file of this SoftwareImage.

        A file (e.g., Dockerfile) with executable instructions indicating how a Software Image or a Software component is built  # noqa: E501

        :param has_build_file: The has_build_file of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._has_build_file = has_build_file

    @property
    def short_description(self):
        """Gets the short_description of this SoftwareImage.  # noqa: E501

        A summarized description of the resource  # noqa: E501

        :return: The short_description of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._short_description

    @short_description.setter
    def short_description(self, short_description):
        """Sets the short_description of this SoftwareImage.

        A summarized description of the resource  # noqa: E501

        :param short_description: The short_description of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._short_description = short_description

    @property
    def has_execution_command(self):
        """Gets the has_execution_command of this SoftwareImage.  # noqa: E501

        Execution instructions on how to run the image  # noqa: E501

        :return: The has_execution_command of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._has_execution_command

    @has_execution_command.setter
    def has_execution_command(self, has_execution_command):
        """Sets the has_execution_command of this SoftwareImage.

        Execution instructions on how to run the image  # noqa: E501

        :param has_execution_command: The has_execution_command of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._has_execution_command = has_execution_command

    @property
    def date_published(self):
        """Gets the date_published of this SoftwareImage.  # noqa: E501

        Date when a software component was published  # noqa: E501

        :return: The date_published of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._date_published

    @date_published.setter
    def date_published(self, date_published):
        """Sets the date_published of this SoftwareImage.

        Date when a software component was published  # noqa: E501

        :param date_published: The date_published of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._date_published = date_published

    @property
    def license(self):
        """Gets the license of this SoftwareImage.  # noqa: E501

        License of a software component or its source code  # noqa: E501

        :return: The license of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._license

    @license.setter
    def license(self, license):
        """Sets the license of this SoftwareImage.

        License of a software component or its source code  # noqa: E501

        :param license: The license of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._license = license

    @property
    def has_source_code(self):
        """Gets the has_source_code of this SoftwareImage.  # noqa: E501

        Property designed to link a software with its software source code (which may reside in a code repository such as GitHub)  # noqa: E501

        :return: The has_source_code of this SoftwareImage.  # noqa: E501
        :rtype: list[SourceCode]
        """
        return self._has_source_code

    @has_source_code.setter
    def has_source_code(self, has_source_code):
        """Sets the has_source_code of this SoftwareImage.

        Property designed to link a software with its software source code (which may reside in a code repository such as GitHub)  # noqa: E501

        :param has_source_code: The has_source_code of this SoftwareImage.  # noqa: E501
        :type: list[SourceCode]
        """

        self._has_source_code = has_source_code

    @property
    def has_example(self):
        """Gets the has_example of this SoftwareImage.  # noqa: E501

        An example explaining a scenario where the software component was used in plain language.  # noqa: E501

        :return: The has_example of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._has_example

    @has_example.setter
    def has_example(self, has_example):
        """Sets the has_example of this SoftwareImage.

        An example explaining a scenario where the software component was used in plain language.  # noqa: E501

        :param has_example: The has_example of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._has_example = has_example

    @property
    def publisher(self):
        """Gets the publisher of this SoftwareImage.  # noqa: E501

        Publisher organization or person responsible for a software component  # noqa: E501

        :return: The publisher of this SoftwareImage.  # noqa: E501
        :rtype: list[object]
        """
        return self._publisher

    @publisher.setter
    def publisher(self, publisher):
        """Sets the publisher of this SoftwareImage.

        Publisher organization or person responsible for a software component  # noqa: E501

        :param publisher: The publisher of this SoftwareImage.  # noqa: E501
        :type: list[object]
        """

        self._publisher = publisher

    @property
    def doi(self):
        """Gets the doi of this SoftwareImage.  # noqa: E501

        Digital Object Identifier associated with a software component  # noqa: E501

        :return: The doi of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._doi

    @doi.setter
    def doi(self, doi):
        """Sets the doi of this SoftwareImage.

        Digital Object Identifier associated with a software component  # noqa: E501

        :param doi: The doi of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._doi = doi

    @property
    def has_funding(self):
        """Gets the has_funding of this SoftwareImage.  # noqa: E501

        Property that links a software project to its funding information  # noqa: E501

        :return: The has_funding of this SoftwareImage.  # noqa: E501
        :rtype: list[FundingInformation]
        """
        return self._has_funding

    @has_funding.setter
    def has_funding(self, has_funding):
        """Sets the has_funding of this SoftwareImage.

        Property that links a software project to its funding information  # noqa: E501

        :param has_funding: The has_funding of this SoftwareImage.  # noqa: E501
        :type: list[FundingInformation]
        """

        self._has_funding = has_funding

    @property
    def support_details(self):
        """Gets the support_details of this SoftwareImage.  # noqa: E501

        Property to link details, such as mailing lists in case a contact person is not provided  # noqa: E501

        :return: The support_details of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._support_details

    @support_details.setter
    def support_details(self, support_details):
        """Sets the support_details of this SoftwareImage.

        Property to link details, such as mailing lists in case a contact person is not provided  # noqa: E501

        :param support_details: The support_details of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._support_details = support_details

    @property
    def has_version(self):
        """Gets the has_version of this SoftwareImage.  # noqa: E501

        Property designed to link a software component with its corresponding versions  # noqa: E501

        :return: The has_version of this SoftwareImage.  # noqa: E501
        :rtype: list[SoftwareVersion]
        """
        return self._has_version

    @has_version.setter
    def has_version(self, has_version):
        """Sets the has_version of this SoftwareImage.

        Property designed to link a software component with its corresponding versions  # noqa: E501

        :param has_version: The has_version of this SoftwareImage.  # noqa: E501
        :type: list[SoftwareVersion]
        """

        self._has_version = has_version

    @property
    def has_typical_data_source(self):
        """Gets the has_typical_data_source of this SoftwareImage.  # noqa: E501

        Typical data sources that are used by a software component  # noqa: E501

        :return: The has_typical_data_source of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._has_typical_data_source

    @has_typical_data_source.setter
    def has_typical_data_source(self, has_typical_data_source):
        """Sets the has_typical_data_source of this SoftwareImage.

        Typical data sources that are used by a software component  # noqa: E501

        :param has_typical_data_source: The has_typical_data_source of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._has_typical_data_source = has_typical_data_source

    @property
    def description(self):
        """Gets the description of this SoftwareImage.  # noqa: E501

        small description  # noqa: E501

        :return: The description of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this SoftwareImage.

        small description  # noqa: E501

        :param description: The description of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._description = description

    @property
    def reference_publication(self):
        """Gets the reference_publication of this SoftwareImage.  # noqa: E501

        Main publication to cite for this software component  # noqa: E501

        :return: The reference_publication of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._reference_publication

    @reference_publication.setter
    def reference_publication(self, reference_publication):
        """Sets the reference_publication of this SoftwareImage.

        Main publication to cite for this software component  # noqa: E501

        :param reference_publication: The reference_publication of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._reference_publication = reference_publication

    @property
    def screenshot(self):
        """Gets the screenshot of this SoftwareImage.  # noqa: E501

        Image illustrating a snapshot of the target software  # noqa: E501

        :return: The screenshot of this SoftwareImage.  # noqa: E501
        :rtype: list[Image]
        """
        return self._screenshot

    @screenshot.setter
    def screenshot(self, screenshot):
        """Sets the screenshot of this SoftwareImage.

        Image illustrating a snapshot of the target software  # noqa: E501

        :param screenshot: The screenshot of this SoftwareImage.  # noqa: E501
        :type: list[Image]
        """

        self._screenshot = screenshot

    @property
    def had_primary_source(self):
        """Gets the had_primary_source of this SoftwareImage.  # noqa: E501

        Property to identify the original source of the information of the annotated resource. It could be a web page, an organization, a person, some experiment notes, etc.  # noqa: E501

        :return: The had_primary_source of this SoftwareImage.  # noqa: E501
        :rtype: list[object]
        """
        return self._had_primary_source

    @had_primary_source.setter
    def had_primary_source(self, had_primary_source):
        """Sets the had_primary_source of this SoftwareImage.

        Property to identify the original source of the information of the annotated resource. It could be a web page, an organization, a person, some experiment notes, etc.  # noqa: E501

        :param had_primary_source: The had_primary_source of this SoftwareImage.  # noqa: E501
        :type: list[object]
        """

        self._had_primary_source = had_primary_source

    @property
    def issue_tracker(self):
        """Gets the issue_tracker of this SoftwareImage.  # noqa: E501

        Pointer to the issue tracker of a software component  # noqa: E501

        :return: The issue_tracker of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._issue_tracker

    @issue_tracker.setter
    def issue_tracker(self, issue_tracker):
        """Sets the issue_tracker of this SoftwareImage.

        Pointer to the issue tracker of a software component  # noqa: E501

        :param issue_tracker: The issue_tracker of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._issue_tracker = issue_tracker

    @property
    def date_created(self):
        """Gets the date_created of this SoftwareImage.  # noqa: E501

        Date when a software component was created  # noqa: E501

        :return: The date_created of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._date_created

    @date_created.setter
    def date_created(self, date_created):
        """Sets the date_created of this SoftwareImage.

        Date when a software component was created  # noqa: E501

        :param date_created: The date_created of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._date_created = date_created

    @property
    def contributor(self):
        """Gets the contributor of this SoftwareImage.  # noqa: E501

        Contributor to a software component  # noqa: E501

        :return: The contributor of this SoftwareImage.  # noqa: E501
        :rtype: list[Person]
        """
        return self._contributor

    @contributor.setter
    def contributor(self, contributor):
        """Sets the contributor of this SoftwareImage.

        Contributor to a software component  # noqa: E501

        :param contributor: The contributor of this SoftwareImage.  # noqa: E501
        :type: list[Person]
        """

        self._contributor = contributor

    @property
    def available_in_registry(self):
        """Gets the available_in_registry of this SoftwareImage.  # noqa: E501

        Property that indicates in which registry the software image being described can be found. For example, https://hub.docker.com  # noqa: E501

        :return: The available_in_registry of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._available_in_registry

    @available_in_registry.setter
    def available_in_registry(self, available_in_registry):
        """Sets the available_in_registry of this SoftwareImage.

        Property that indicates in which registry the software image being described can be found. For example, https://hub.docker.com  # noqa: E501

        :param available_in_registry: The available_in_registry of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._available_in_registry = available_in_registry

    @property
    def has_purpose(self):
        """Gets the has_purpose of this SoftwareImage.  # noqa: E501

        Objective or main functionality that can be achieved by running this software  # noqa: E501

        :return: The has_purpose of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._has_purpose

    @has_purpose.setter
    def has_purpose(self, has_purpose):
        """Sets the has_purpose of this SoftwareImage.

        Objective or main functionality that can be achieved by running this software  # noqa: E501

        :param has_purpose: The has_purpose of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._has_purpose = has_purpose

    @property
    def has_executable_instructions(self):
        """Gets the has_executable_instructions of this SoftwareImage.  # noqa: E501

        Instructions that indicate how a software component should be executed. The difference with `hasExecutionCommand` is that the execution instructions aim to be human-readable, and have explanations between the different commands and instructions  # noqa: E501

        :return: The has_executable_instructions of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._has_executable_instructions

    @has_executable_instructions.setter
    def has_executable_instructions(self, has_executable_instructions):
        """Sets the has_executable_instructions of this SoftwareImage.

        Instructions that indicate how a software component should be executed. The difference with `hasExecutionCommand` is that the execution instructions aim to be human-readable, and have explanations between the different commands and instructions  # noqa: E501

        :param has_executable_instructions: The has_executable_instructions of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._has_executable_instructions = has_executable_instructions

    @property
    def has_sample_visualization(self):
        """Gets the has_sample_visualization of this SoftwareImage.  # noqa: E501

        A typical sample visualization of the softwware outputs  # noqa: E501

        :return: The has_sample_visualization of this SoftwareImage.  # noqa: E501
        :rtype: list[Visualization]
        """
        return self._has_sample_visualization

    @has_sample_visualization.setter
    def has_sample_visualization(self, has_sample_visualization):
        """Sets the has_sample_visualization of this SoftwareImage.

        A typical sample visualization of the softwware outputs  # noqa: E501

        :param has_sample_visualization: The has_sample_visualization of this SoftwareImage.  # noqa: E501
        :type: list[Visualization]
        """

        self._has_sample_visualization = has_sample_visualization

    @property
    def memory_requirements(self):
        """Gets the memory_requirements of this SoftwareImage.  # noqa: E501

        Memory requirements of a software  # noqa: E501

        :return: The memory_requirements of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._memory_requirements

    @memory_requirements.setter
    def memory_requirements(self, memory_requirements):
        """Sets the memory_requirements of this SoftwareImage.

        Memory requirements of a software  # noqa: E501

        :param memory_requirements: The memory_requirements of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._memory_requirements = memory_requirements

    @property
    def website(self):
        """Gets the website of this SoftwareImage.  # noqa: E501

        Website of the software  # noqa: E501

        :return: The website of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._website

    @website.setter
    def website(self, website):
        """Sets the website of this SoftwareImage.

        Website of the software  # noqa: E501

        :param website: The website of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._website = website

    @property
    def citation(self):
        """Gets the citation of this SoftwareImage.  # noqa: E501

        How to cite this software  # noqa: E501

        :return: The citation of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._citation

    @citation.setter
    def citation(self, citation):
        """Sets the citation of this SoftwareImage.

        How to cite this software  # noqa: E501

        :param citation: The citation of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._citation = citation

    @property
    def processor_requirements(self):
        """Gets the processor_requirements of this SoftwareImage.  # noqa: E501

        Processor requirements of a software component  # noqa: E501

        :return: The processor_requirements of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._processor_requirements

    @processor_requirements.setter
    def processor_requirements(self, processor_requirements):
        """Sets the processor_requirements of this SoftwareImage.

        Processor requirements of a software component  # noqa: E501

        :param processor_requirements: The processor_requirements of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._processor_requirements = processor_requirements

    @property
    def has_usage_notes(self):
        """Gets the has_usage_notes of this SoftwareImage.  # noqa: E501

        Property that describes the usage considerations of a particular software. These notes capture the rationale of for that software configuration, along with an explanation for sample inputs, things to consider when running the model with data, etc.  # noqa: E501

        :return: The has_usage_notes of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._has_usage_notes

    @has_usage_notes.setter
    def has_usage_notes(self, has_usage_notes):
        """Sets the has_usage_notes of this SoftwareImage.

        Property that describes the usage considerations of a particular software. These notes capture the rationale of for that software configuration, along with an explanation for sample inputs, things to consider when running the model with data, etc.  # noqa: E501

        :param has_usage_notes: The has_usage_notes of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._has_usage_notes = has_usage_notes

    @property
    def readme(self):
        """Gets the readme of this SoftwareImage.  # noqa: E501

        URl to the readme file of a software component  # noqa: E501

        :return: The readme of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._readme

    @readme.setter
    def readme(self, readme):
        """Sets the readme of this SoftwareImage.

        URl to the readme file of a software component  # noqa: E501

        :param readme: The readme of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._readme = readme

    @property
    def label(self):
        """Gets the label of this SoftwareImage.  # noqa: E501

        short description of the resource  # noqa: E501

        :return: The label of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._label

    @label.setter
    def label(self, label):
        """Sets the label of this SoftwareImage.

        short description of the resource  # noqa: E501

        :param label: The label of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._label = label

    @property
    def has_assumption(self):
        """Gets the has_assumption of this SoftwareImage.  # noqa: E501

        Assumptions of a software, e.g. the solver being used for a particular model, the source of the data (e.g., all data must have a given resolution), etc.  # noqa: E501

        :return: The has_assumption of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._has_assumption

    @has_assumption.setter
    def has_assumption(self, has_assumption):
        """Sets the has_assumption of this SoftwareImage.

        Assumptions of a software, e.g. the solver being used for a particular model, the source of the data (e.g., all data must have a given resolution), etc.  # noqa: E501

        :param has_assumption: The has_assumption of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._has_assumption = has_assumption

    @property
    def operating_systems(self):
        """Gets the operating_systems of this SoftwareImage.  # noqa: E501

        Operating systems under which a software component can operate  # noqa: E501

        :return: The operating_systems of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._operating_systems

    @operating_systems.setter
    def operating_systems(self, operating_systems):
        """Sets the operating_systems of this SoftwareImage.

        Operating systems under which a software component can operate  # noqa: E501

        :param operating_systems: The operating_systems of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._operating_systems = operating_systems

    @property
    def has_executable_notebook(self):
        """Gets the has_executable_notebook of this SoftwareImage.  # noqa: E501

        Property that links a software component with an executable notebook (e.g., Jupyter notebook) that illustrates how to use it in an executable manner.  # noqa: E501

        :return: The has_executable_notebook of this SoftwareImage.  # noqa: E501
        :rtype: list[str]
        """
        return self._has_executable_notebook

    @has_executable_notebook.setter
    def has_executable_notebook(self, has_executable_notebook):
        """Sets the has_executable_notebook of this SoftwareImage.

        Property that links a software component with an executable notebook (e.g., Jupyter notebook) that illustrates how to use it in an executable manner.  # noqa: E501

        :param has_executable_notebook: The has_executable_notebook of this SoftwareImage.  # noqa: E501
        :type: list[str]
        """

        self._has_executable_notebook = has_executable_notebook

    @property
    def useful_for_calculating_index(self):
        """Gets the useful_for_calculating_index of this SoftwareImage.  # noqa: E501

        Property that indicates that a software component (or any of its outputs) can be used to calculate a particular index. The rationale for this property is that indices are usually calculated by applying post-processing steps to the outputs of a software component.  # noqa: E501

        :return: The useful_for_calculating_index of this SoftwareImage.  # noqa: E501
        :rtype: list[NumericalIndex]
        """
        return self._useful_for_calculating_index

    @useful_for_calculating_index.setter
    def useful_for_calculating_index(self, useful_for_calculating_index):
        """Sets the useful_for_calculating_index of this SoftwareImage.

        Property that indicates that a software component (or any of its outputs) can be used to calculate a particular index. The rationale for this property is that indices are usually calculated by applying post-processing steps to the outputs of a software component.  # noqa: E501

        :param useful_for_calculating_index: The useful_for_calculating_index of this SoftwareImage.  # noqa: E501
        :type: list[NumericalIndex]
        """

        self._useful_for_calculating_index = useful_for_calculating_index

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SoftwareImage):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
